%global commit b08c9fa390424e870651806daad6d765a438ec45

Summary:	Daemon that finds starving tasks and gives them a temporary boost
Name:		stalld
Version:	1.17.2
Release:	5%{?dist}
License:	GPLv2
URL:		https://gitlab.com/rt-linux-tools/%{name}/%{name}.git
Source0:	https://gitlab.com/rt-linux-tools/%{name}/-/archive/v%{version}/%{name}-%{version}.tar.bz2 #/%{name}-%{commit}.tar.bz2

# https://gitlab.com/rt-linux-tools/stalld/-/commit/ff284f68a07806b9460ffd48747d3ded0e71c4e3
Patch0001:	0001-fix-stalld.service-start-fail-when-selinux-on.patch
Patch5001:	0002-stalld.service-Fix-failure-to-set-FIFO-scheduling-cl.patch

BuildRequires:	gcc make glibc-devel
BuildRequires:	systemd-rpm-macros
Requires:	systemd util-linux-core

%description
The stalld program monitors the set of system threads, looking for threads
that are ready-to-run but have not been given processor time for some threshold period.
When a starving thread is found, it is given a temporary boost using the SCHED_DEADLINE
policy. The default is to allow 10 microseconds of runtime for 1 second of clock time.


%prep
%autosetup -n %{name}-%{commit} -p1


%build
%make_build CFLAGS="%{optflags} %{build_cflags} -DVERSION="\\\"%{version}\\\"""  LDFLAGS="%{build_ldflags}"


%install
%make_install DOCDIR=%{_docdir} MANDIR=%{_mandir} BINDIR=%{_bindir} DATADIR=%{_datadir} VERSION=%{version}
%make_install -C redhat UNITDIR=%{_unitdir}


%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service


%files
%license gpl-2.0.txt
%doc %{_docdir}/README.md
%config(noreplace) %{_sysconfdir}/sysconfig/stalld
%{_unitdir}/%{name}.service
%{_bindir}/%{name}
%{_bindir}/throttlectl
%{_mandir}/man8/stalld.8*


%changelog
* Wed Apr 24 2024 luffyluo <luffyluo@tencent.com> - 1.17.2-5
- fix stalld.service start fail

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.17.2-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.17.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.17.2-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 29 2023 rockerzhu <rockerzhu@tencent.com> - 1.17.2-1
- Initial build
